import java.io.*;
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;
import org.antlr.stringtemplate.*;


public class Test {
    public static void main(String[] args) throws Exception {
				// adujemy szablony
				FileReader groupFile = new FileReader("pierwszy.stg");
				StringTemplateGroup templates = new StringTemplateGroup(groupFile);
				groupFile.close();


        // Tworzymy analizator leksykalny i kaemy mu czyta z stdin
        ANTLRInputStream input = new ANTLRInputStream(System.in);
        ExprLexer lexer = new ExprLexer(input);

        // Tworzymy bufor na tokeny pomiedzy analizatorem leksykalnym a parserem
        CommonTokenStream tokens = new CommonTokenStream(lexer);

        // Tworzymy parser czytajcy z powyszego bufora
        ExprParser parser = new ExprParser(tokens);


        try {
          // Wywoujemy parser generujcy drzewo startujc od reguy prog (Z klasy Expr)
          ExprParser.prog_return root = parser.prog();

          // Tworzymy bufor na wzy drzewa
          CommonTreeNodeStream nodes = new CommonTreeNodeStream(root.tree);

          // Tworzymy parser drzew korzystajcy z powyszego bufora
          TExpr walker = new TExpr(nodes);

					// Tumaczymy parserowi drzew, jakich szablonw ma uywa
					walker.setTemplateLib(templates);

          // Wywoujemy parser drzew - startujc od reguy prog (Tym razem z klasy TExpr!)
          TExpr.prog_return tpl = walker.prog();

					// Pobierz "wypeniony" szablon
          StringTemplate stp = (StringTemplate) tpl.getTemplate();

          // Wypisujemy drzewo na standardowe wyjcie
          System.out.println(((CommonTree)root.tree).toStringTree());

					// Wypisujemy wypeniony szablon
          System.out.println(stp.toString());

        } catch (RecognitionException e) {
            e.printStackTrace();
        }

    }
}
